##############################################################
## MOD Title: phpBB Digests
## MOD Author: MarkDHamill < mhamill@computer.org > (Mark D. Hamill) http://phpbb.potomactavern.org
## MOD Description: Sends customized email digests of forum messages to subscribers
## MOD Version: 1.0.17, 6 May 2007
##
## Installation Level: Advanced
## Installation Time: 60 Minutes to several days, depending on whether you need to set up SSH and
##                    your skills at the server operating system command line.
## Files To Edit: 
##   profile.php
##   admin/admin_users.php
##   includes/page_header.php
##   includes/usercp_activate.php
##   includes/usercp_register.php
##   language/lang_english/lang_admin.php
##   language/lang_french/lang_admin.php
##   language/lang_english/lang_faq.php
##   language/lang_french/lang_faq.php
##   templates/subSilver/overall_header.tpl
##
## Included Files: 
##   digests.php, mail_digests.php, admin_digests_add.php, admin_digests_config.php, admin_digests_modify.php,
##   digest_functions.php, digest_emailer.php, digest_tables.php, digest_db_update.php, lang_digests.php,
##   mail_digests_html.tpl (English), mail_digests_text.tpl (English), lang_digests.php (English)
##   mail_digests_html.tpl (French), mail_digests_text.tpl (French), lang_digests.php (French)
##   digests_body.tpl, digests_add_body.tpl, digests_config_body.tpl, digests_modify_body.tpl, icon_mini_digest.gif
##
## License: http://opensource.org/licenses/gpl-license.php GNU General Public License v2
############################################################## 
## For security purposes, please check: http://www.phpbb.com/mods/
## for the latest version of this MOD. Although MODs are checked
## before being allowed in the MODs Database there is no guarantee
## that there are no security problems within the MOD. No support
## will be given for MODs not found within the MODs Database which
## can be found at http://www.phpbb.com/mods/
##############################################################
## Author Notes:
## 
## IMPORTANT NOTE: This mod is EasyMod compatible, however there is MUCH more work to installing this mod.
## 
## Since this is a very complex mod to install, please refer to this web page for installation instructions.
## HOWEVER, when making changes to phpBB, please copy and paste the source code in this file, as what is 
## shown on the web page will not indent correctly.
##
## DIGEST INSTALLATION PAGE: http://phpbb.potomactavern.org/digests/installation.htm
##
## Due to the complexity of installing this mod, I may agree to install this for you for a fee. If interested, see 
## this web page: http://phpbb.potomactavern.org/services.
##
## The official and supported version of this mod is available only on the phpBB web site. However, I do maintain an 
## offsite version that may include new "beta" features and bug fixes that are not official. These unofficial versions 
## should be used with caution. The latest unofficial version can be downloaded from: 
## http://phpbb.potomactavern.org/digests/
##
##############################################################
## 
## MOD History: See http://phpbb.potomactavern.org/digests/  
## 
############################################################## 
## Before Adding This MOD To Your Forum, You Should Back Up All Files Related To This MOD
##############################################################

# 
#-----[ COPY ]------------------------------------------
#
copy digests.php to digests.php
copy mail_digests.php to mail_digests.php
copy admin/admin_digests_add.php to admin/admin_digests_add.php
copy admin/admin_digests_config.php to admin/admin_digests_config.php
copy admin/admin_digests_modify.php to admin/admin_digests_modify.php
copy includes/digest_functions.php to includes/digest_functions.php 
copy includes/digest_emailer.php to includes/digest_emailer.php
copy install/digest_tables.php to install/digest_tables.php
copy language/lang_english/lang_digests.php to language/lang_english/lang_digests.php
copy language/lang_english/email/mail_digests_html.tpl to language/lang_english/email/mail_digests_html.tpl
copy language/lang_english/email/mail_digests_text.tpl to language/lang_english/email/mail_digests_text.tpl
copy language/lang_french/lang_digests.php to language/lang_french/lang_digests.php
copy language/lang_french/email/mail_digests_html.tpl to language/lang_french/email/mail_digests_html.tpl
copy language/lang_french/email/mail_digests_text.tpl to language/lang_french/email/mail_digests_text.tpl
copy templates/subSilver/digests_body.tpl to templates/subSilver/digests_body.tpl
copy templates/subSilver/admin/digests_add_body.tpl to templates/subSilver/admin/digests_add_body.tpl
copy templates/subSilver/admin/digests_config_body.tpl to templates/subSilver/admin/digests_config_body.tpl
copy templates/subSilver/admin/digests_modify_body.tpl to templates/subSilver/admin/digests_modify_body.tpl
copy templates/subSilver/images/icon_mini_digest.gif to templates/subSilver/images/icon_mini_digest.gif

#
#-----[ OPEN ]------------------------------------------
#
profile.php

#
#-----[ FIND ]------------------------------------------
#
	else if ( $mode == 'activate' )
	{

#
#-----[ AFTER, ADD ]------------------------------------------
#
		// Begin Digest Mod
		include($phpbb_root_path . 'includes/digest_functions.' . $phpEx);
		// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
admin/admin_users.php

#
#-----[ FIND ]------------------------------------------
#
require($phpbb_root_path . 'includes/functions_validate.'.$phpEx);

#
#-----[ AFTER, ADD ]------------------------------------------
#
// Begin Digest Mod
include($phpbb_root_path . 'includes/digest_functions.' . $phpEx);
// End Digest Mod

#
#-----[ FIND ]------------------------------------------
#
				if ( !$db->sql_query($delete_text_sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete private message text', '', __LINE__, __FILE__, $delete_text_sql);
				}
			}
			
#
#-----[ AFTER, ADD ]------------------------------------------
#
			// Begin Digest Mod
			// Delete digests subscriptions, if any. 
			
			// First remove all individual forum subscriptions
			$sql = 'DELETE FROM ' . DIGEST_SUBSCRIBED_FORUMS_TABLE . ' WHERE user_id = ' . $user_id;
	
			if ( !($result = $db->sql_query($sql)))
			{
				message_die(GENERAL_ERROR, 'Could not delete from ' . DIGEST_SUBSCRIBED_FORUMS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
			}
		
			// remove subscription itself
			$sql = 'DELETE FROM ' . DIGEST_SUBSCRIPTIONS_TABLE . ' WHERE user_id = ' . $user_id;
	
			if ( !($result = $db->sql_query($sql)))
			{
				message_die(GENERAL_ERROR, 'Could not delete from ' . DIGEST_SUBSCRIPTIONS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
			}
			// End Digest Mod

#
#-----[ FIND ]------------------------------------------
#
			else
			{
				message_die(GENERAL_ERROR, 'Admin_user_fail', '', __LINE__, __FILE__, $sql);
			}
			
#
#-----[ AFTER, ADD ]------------------------------------------
#
			
			// Begin Digest Mod
			if ($user_status)
			{
				// Subscribe to a digest, if board is so enabled
				autosubscribe_digest($user_id);
			}
			else
			{
				// If the user is becoming inactive, remove their digest subscription
				save_digest_settings ($user_id, 'DEL');
			}
			// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
includes/page_header.php

#
#-----[ FIND ]------------------------------------------
#
define('HEADER_INC', TRUE);

#
#-----[ AFTER, ADD ]------------------------------------------
#
// Begin Digest Mod
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_digests.' . $phpEx);
// End Digest Mod

#
#-----[ FIND ]------------------------------------------
#
	$l_login_logout = $lang['Logout'] . ' [ ' . $userdata['username'] . ' ]';

#
#-----[ AFTER, ADD ]------------------------------------------
#
	// Begin Digest Mod
	$template->assign_block_vars('switch_show_digests', array());
	// End Digest Mod

#
#-----[ FIND ]------------------------------------------
#
	'L_MEMBERLIST' => $lang['Memberlist'], 

#
#-----[ AFTER, ADD ]------------------------------------------
#
	// Begin Digest Mod
	'L_DIGESTS' => $lang['digest_page_title_short'], 
	// End Digest Mod

#
#-----[ FIND ]------------------------------------------
#
	'U_MEMBERLIST' => append_sid('memberlist.'.$phpEx), 

#
#-----[ AFTER, ADD ]------------------------------------------
#
	// Begin Digest Mod
	'U_DIGESTS' => append_sid('digests.'.$phpEx), 
	// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
includes/usercp_activate.php

#
#-----[ FIND ]------------------------------------------
#
		$sql = "UPDATE " . USERS_TABLE . "
			SET user_active = 1, user_actkey = ''" . $sql_update_pass . " 
			WHERE user_id = " . $row['user_id']; 
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql_update);
		}

#
#-----[ AFTER, ADD ]------------------------------------------
#
		// Begin Digest Mod
		autosubscribe_digest($row['user_id']);
		// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
includes/usercp_register.php

#
#-----[ FIND ]------------------------------------------
#
			{
				$message = $lang['Account_added'];
				$email_template = 'user_welcome';

#
#-----[ AFTER, ADD ]------------------------------------------
#
				// Begin Digest Mod
				include($phpbb_root_path . 'includes/digest_functions.' . $phpEx);
				autosubscribe_digest($user_id);
				// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
language/lang_english/lang_admin.php

#
#-----[ FIND ]------------------------------------------
#
$lang['Restore_DB'] = 'Restore Database';

#
#-----[ AFTER, ADD ]------------------------------------------
#
// Begin Digest Mod
$lang['Digests'] ='Digests Admin';
$lang['Digests_Modify_Subscribers']='Modify Subscribers';
$lang['Digests_Add_Subscribers']='Add Subscribers';
$lang['Digests_Configuration']='Configuration';
// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
language/lang_french/lang_admin.php

#
#-----[ FIND ]------------------------------------------
#
$lang['Restore_DB'] = 'Restaurer la base de donnes';

#
#-----[ AFTER, ADD ]------------------------------------------
#
// Begin Digest Mod
$lang['Digests'] ='Administration des abonnements';
$lang['Digests_Modify_Subscribers']='Modifier les abonnements';
$lang['Digests_Add_Subscribers']='Ajouter des abonnements';
$lang['Digests_Configuration']='Configuration';
// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
language/lang_english/lang_faq.php

#
#-----[ FIND ]------------------------------------------
#
//
// This ends the FAQ entries
//

#
#-----[ BEFORE, ADD ]------------------------------------------
#
// Begin Digest Mod
$faq[] = array("--","Digests");
$faq[] = array("What are Digests?", "Digests are email messages sent to you periodically with summary of postings made here. Weekly or daily digests are available.");
$faq[] = array("Why would I want a digest?", "It makes your life easier. You don't have to explicitly visit this site to see what conversations are going on around here. Just read your digest and if there is some topic that seems of interest, click on it in your email program and start participating! Unsubscribe at any time.");
$faq[] = array("How often are digests sent?", "They can be sent daily or weekly. Weekly digests are sent on the day set by the board's administrator.");
$faq[] = array("When are digests sent?", "You determine the hour you want to receive the digest. Whatever time you choose, you will always get the latest news so pick a time that suits your lifestyle.");
$faq[] = array("What time period is covered by the digest?", "Either 24 hours or 7 days, depending on whether you selected a daily or weekly digest. Messages older than this will not be sent. In addition if you want you can elect not to see messages since you last logged in, if you visited recently. You can even filter out your own messages.");
$faq[] = array("Suppose I don't want summaries of every message here. Can I be selective?", "Yes. You can pick the forum or forums that interest you. By default you will get messages for all forums that you are allowed to access.");
$faq[] = array("What email message formats are available?", "We can send you HTML or text. Unless your email program can't handle HTML (very unusual these days) we suggest HTML. Frankly, text digests look pretty plain and are harder to use. That's the nature of plain text. There are two variations of HTML formatted email. The Enhanced HTML embeds images and board smilies. The Plain HTML provides a simpler HTML format.");
$faq[] = array("Do I get the whole message text in the digest?", "You can choose how much post text comes in your digest. The default is set by the board administrator. You can choose to see the entire message or the first 50, 100, 150, 300 or 600 characters of each post. Anything beyond the limit you set will be truncated. If the board is a busy board, we recommend using a lower message length because otherwise your digests may get so big as to be unusable. We have also heard that very large digests may be rejected by your ISP or put you over your server storage quota. An excerpt reduces bandwidth and is usually all that is needed. Why? Because each message has a convenient link that will take you to the topic or message of interest.");
$faq[] = array("How do I get started?", "Just click on the Digests link near the top right part of any page. Or if you prefer <a href=\"./digests.php\">click here</a>.");
$faq[] = array("Can I unsubscribe?", "Of course! Just go to the same page and select \"None\" for \"Type of Digest Wanted\". Then submit the form. Your subscription will end immediately.");
$faq[] = array("Are digests commercial free?", "There is no advertising embedded in the digest. It is possible that someone will post a message on this board that is the equivalent of spam.");
$faq[] = array("Is my privacy protected?", "Yes, your digest is sent to you and no one else at the email address you gave us in your profile. Think of the digest as a special edition newspaper customized just for you. Someone else is likely getting a completely different digest.");
$faq[] = array("Why are there private messages in my digest?", "As for version 1.0.17 of the phpBB Digest Mod, private message can appear in the digest. If you edit your digest settings using the link at the bottom of the digest, you can turn off the private messaging feature.");
$faq[] = array("I am getting a digest and I did not subscribe. Why?", "The board administrator either set a policy requiring all new users to receive digests by default, or he enrolled you to receive a digest using an interface in the Administrator Control Panel. You can use the link at the bottom of the digest to unsubscribe. If you are upset about being subscribed against your will, complain to the board administrator. The author of this modification to phpBB cannot rectify your problem.");
// End Digest Mod

#
#-----[ OPEN ]------------------------------------------
#
language/lang_french/lang_faq.php

#
#-----[ FIND ]------------------------------------------
#
//
// This ends the FAQ entries
//

#
#-----[ BEFORE, ADD ]------------------------------------------
#
// Begin Digest Mod
$faq[] = array("--","Abonnements");
$faq[] = array("Que sont les compte-rendus?", "Les compte-rendus sont des courriels qui vous sont envoys priodiquement avec le rsum des messages posts ici. Des compte-rendus quotidiens ou hebdomadaires sont disponibles.");
$faq[] = array("Pourquoi voudrais-je un compte-rendu?", "Car il vous simplifie la vie. Vous n'avez pas  visiter explicitement ce site afin de suivre les conversations qui s'y tiennent. Vous n'avez qu' lire votre compte-rendu et si un sujet vous semble d'intrt, cliquez sur celui-ci depuis votre logiciel de messagerie et participez  la discussion! Vous pouvez vous dsinscrire  tout moment.");
$faq[] = array(" quelle frquence les compte-rendus sont-ils envoys?", "Ils peuvent tre envoys sur une base quotidienne ou hebdomadaire. Les compte-rendus hebdomadaires sont envoys le jour slectionn par l'administrateur.");
$faq[] = array(" quel moment les compte-rendus sont-ils envoys?", "Vous dterminez l'heure  laquelle vous aimeriez recevoir votre compte-rendu. Peu importe l'heure choisie, vous recevrez toujours les dernires nouvelles; slectionnez-en une qui cadre avec votre style de vie.");
$faq[] = array("Quelle priode de temps est couverte par le compte-rendu?", "Soit 24 heures ou 7 jours, en fonction de votre slection d'envoi sur une base quotidienne ou hebdomadaire. Les messages plus anciens que cela ne seront pas envoys. De plus, vous pouvez choisir de ne pas inclure les messages posts depuis votre dernire connexion au site si vous avez visit celui-ci dernirement. Vous pouvez aussi exclure vos propres messages des compte-rendus.");
$faq[] = array("Supposons que je ne dsire pas recevoir un compte-rendu de tous les messages posts ici. Puis-je tre slectif?", "Oui. Vous pouvez slectionner le ou les forums qui vous intressent. Par dfaut, vous recevrez les messages de tous les forums auxquels vous avez l'autorisation d'accder.");
$faq[] = array("Quels formats de courriel sont disponibles?", "Nous pouvons vous envoyer vos compte-rendus au format HTML ou texte.  moins que votre logiciel de messagerie ne puisse traiter le HTML (ce qui est trs rare de nos jours), nous recommendons le format HTML. Honntement, les compte-rendus au format texte sont d'une apparence plutt terne et sont plus difficiles  lire. C'est la nature du simple texte. Il y a deux variantes disponibles pour le format HTML. Le HTML avanc inclut les images et les moticnes dans le compte-rendu. Le HTML simple offre une mise en page plus minimaliste.");
$faq[] = array("Recevrai-je tout le texte du message dans le compte-rendu?", "Vous choisissez le nombre de caractres  inclure pour chacun des messages apparaissant dans votre compte-rendu. La valeur par dfaut est dfinie par l'administrateur. Vous pouvez demander  recevoir la totalit du texte ou les 50, 100, 150, 300 ou 600 premiers caractres des messages. Tout ce qui se trouve au-del de la limite que vous indiquerez sera tronqu. Si le forum est trs actif, nous vous recommandons d'utiliser une quantit de caractres infrieure puisqu'autrement, vos compte-rendus pourraient atteindre une taille si importante qu'ils deviendraient inutilisables. Il est galement possible que des compte-rendus de taille trop importante soient rejets par votre FAI ou dpasse votre quota d'espace allou. Un extrait rduit l'utilisation de la bande passante et suffit gnralement amplement. Pourquoi? Parce que chacun des messages offre un lien qui vous mnera vers le sujet ou message en question.");
$faq[] = array("Par o dois-je dbuter?", "Cliquez simplement sur le lien <i>Abonnements</i> dans le menu apparaissant au haut de chacune des pages. Si vous prfrez, <a href=\"./digests.php\">cliquez ici</a>.");
$faq[] = array("Puis-je me dsinscrire?", "Bien sr! Retournez simplement sur la mme page et slectionnez <i>Aucun</i> pour le <i>Type de compte-rendu dsir</i>. Soumettez ensuite le formulaire. Votre abonnement prendra fin immdiatement.");
$faq[] = array("Les compte-rendus sont-ils exempts de publicit?", "Il n'y a aucune publicit d'inclus dans nos compte-rendus. Il est tout de mme possible que quelqu'un poste un message tant l'quivalent de SPAM sur ce forum.");
$faq[] = array("Ma vie prive est-elle protge?", "Oui, votre compte-rendu est envoy  vous-mme et personne d'autre  l'adresse qui figure dans votre <i>Profil</i>. Pensez aux compte-rendus comme  une dition spciale d'un journal personnalise spcifiquement pour vous. Quelqu'un d'autre reoit probablement un compte-rendu compltement diffrent du vtre.");
$faq[] = array("Pourquoi y a-t-il des messages privs dans mon compte-rendu?", "Depuis la version 1.0.17 du module phpBB Digest, les messages privs peuvent tre inclus dans le compte-rendu. Si vous modifiez les paramtres de votre compte-rendu en utilisant le lien figurant au bas de celui-ci, vous pouvez dsactiver l'affichage des messages privs.");
$faq[] = array("Je reois un compte-rendu alors que je ne me suis jamais abonn. Pourquoi?", "Soit que l'administrateur du forum abonne automatiquement tous les nouveaux utilisateurs aux compte-rendus, soit qu'il vous a abonn en utilisant une interface disponible depuis le panneau de contrle de l'administrateur. Vous pouvez utiliser le lien figurant au bas de votre compte-rendu pour vous dsinscrire. Si cela vous dplait d'avoir t abonn sans votre accord pralable, veuillez vous adresser  l'administrateur de ce forum. L'auteur de ce module pour phpBB ne peut corriger votre problme.");
// End Digest Mod
#
#-----[ OPEN ]------------------------------------------
#
templates/subSilver/overall_header.tpl

#
#-----[ FIND ]------------------------------------------
#
						<!-- BEGIN switch_user_logged_out -->


#
#-----[ BEFORE, ADD ]------------------------------------------
#
						<!-- BEGIN switch_show_digests -->
						&nbsp;<a href="{U_DIGESTS}" class="mainmenu"><img src="templates/subSilver/images/icon_mini_digest.gif" width="12" height="13" border="0" alt="{L_DIGESTS}" hspace="3" />{L_DIGESTS}</a>&nbsp;
						<!-- END switch_show_digests -->

#
#-----[ SAVE/CLOSE ALL FILES ]------------------------------------------
#
# EoM  
